%%
%Shrinking Net Algorithm
%

function sna(fhd,ii,jj,kk,args,mpcORIGINAL)

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
global proc
global ps
 global mpc
% Reinitialization of local
% function evaluation counter.
proc.i_eval=0;
% Function evaluation at which
% the last update of the global
% best solution occurred.
% Refers to the internal evaluation
% using static penalty constraint
% handling method.
proc.last_improvement=1;
% Signalizing your
% to stop running.
proc.finish=0;
% Size of the swarm.
n_par=proc.pop_size;
% For dynamic weight adaption.
me=proc.n_eval;
% Dimensionality of test case.
D=ps.D*6; % PLEASE NOTE THAT 6 time instances are considered

            %CAPACITY LIMITS FOR EVs (Note that the condition of the EV can be Vehicle To Grid or Vehicle Battery Charge)
            ps.x_min(25)=-8;
            ps.x_min(36)=-8;
            ps.x_min(40)=-8;
            ps.x_min(53)=-8;
            ps.x_max(25)=3.6;
            ps.x_max(36)=3.6;
            ps.x_max(40)=3.6;
            ps.x_max(53)=3.6;
            
            %CAPACITY LIMITS FOR WIND GENERATORS
            ps.x_min(10)=15;
            ps.x_min(12)=15;
            ps.x_max(10)=150;
            ps.x_max(12)=150;
            
            %CAPACITY LIMITS FOR SOLAR GENERATORS
            ps.x_min(1)=2;
            ps.x_min(2)=2;
            ps.x_max(1)=20;
            ps.x_max(2)=20;
            
            % Dimensionality of test case.
            % Particles' lower bounds.
            VRmin=[ps.x_min ps.x_min ps.x_min ps.x_min ps.x_min ps.x_min];
            % Particles' upper bounds.
            VRmax=[ps.x_max ps.x_max ps.x_max ps.x_max ps.x_max ps.x_max];
            %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
            
            
%   mpcORIGINAL=mpc;

             global fitTOTAL
             global objTOTAL
             global g_sumTOTAL
             global in_var_ROTOTAL
             fitTOTAL=[];
             objTOTAL=[];
             g_sumTOTAL=[];
             in_var_ROTOTAL=[];
 %    i=2;
%%

% *******************************************************
%   Initialization: Particals of all hyperplane
%	This is one of the most important parts of SNA
% *******************************************************
% Dimensionality of test case.
VariNum=D;
%Number of particals of each hyperplane
PtcNum_Hyp=4;
%Number of particals of all hyperplane
n_par=1500;
n_par_pri=(VariNum/6)*2*PtcNum_Hyp;
n_par_add=n_par-n_par_pri;
proc.pop_size=n_par;
args{3}=n_par;
args{4}=6*n_par;
pos_block=zeros(n_par,VariNum/6);
%Assigning values to "pos"
for a=1:VariNum/6
    for b=1:PtcNum_Hyp
        for k=1:VariNum/6
            if k==a
                pos_block(b+(a-1)*PtcNum_Hyp*2,k)=VRmin(k);
            else
                pos_block(b+(a-1)*PtcNum_Hyp*2,k)=rand*(VRmax(k)-VRmin(k))+VRmin(k);
            end
        end
        for k=1:VariNum/6
            if k==a
                pos_block(b+(a-1)*PtcNum_Hyp*2+PtcNum_Hyp,k)=VRmax(k);
            else
                pos_block(b+(a-1)*PtcNum_Hyp*2+PtcNum_Hyp,k)=rand*(VRmax(k)-VRmin(k))+VRmin(k);
            end
        end
    end
end
pos=[pos_block,pos_block,pos_block,pos_block,pos_block,pos_block];
pos(n_par_pri+1:end,:)=VRmin+(VRmax-VRmin).*rand(n_par_add,VariNum);

%%
% *******************************************************
%   Initialization: Algorithm Parameters
% *******************************************************

%Max Iteration Number
MaxIter             =10;
%Current Iteration Nuber
Count               =0;
%Current Best  "Pos" Recorder
CurrBestPos     =       zeros(MaxIter,VariNum);
%Current Best Fitness Recorder
CurrBestResult =       zeros(MaxIter,1);
%Last "Pos" Value
LastPos           =       pos;
%Original Exploiting Coefficient,the greater it is, the more the global optimization capability is
C_ori           =      2;

%%

while 1
    Count   =       Count+1;
     %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
      [fit,obj,g_sum,pos]=UC(fhd,ii,jj,kk,args,pos,mpcORIGINAL);
      %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    [CurrBestResult(Count,1),CurrBest]=min(fit);
    CurrBestPos(Count,:)=pos(CurrBest,:);
    MaxV    =       (Count)/MaxIter;
    C=C_ori*exp((-Count*2)/(MaxIter));
    CurrBestPosRep=repmat(CurrBestPos(Count,:),n_par,1);
    
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    pos=pos+rand(n_par,VariNum)*C*MaxV.*(CurrBestPosRep-pos)-rand(n_par,VariNum)*(C-1)*MaxV.*(CurrBestPosRep-pos);
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    pos=((pos>=VRmin)&(pos<=VRmax)).*pos+(pos<VRmin).*VRmin+(pos>VRmax).*VRmax;
    if proc.finish
        return;
    end
end
end